
Ruby - Bug #9291

array splatting a nil works, but hash splatting a nil does not

12/24/2013 07:17 PM - rits (First Last)

Status: Rejected   

Priority: Normal   

Assignee: matz (Yukihiro Matsumoto)   

Target version:    

ruby -v: ruby 2.0.0p353 (2013-11-22 revision

43784) [i686-linux]

Backport:  

Description

irb(main):001:0> [*nil]

=> []

irb(main):002:0> {**nil}

TypeError: no implicit conversion of nil into Hash

Related issues:

Is duplicate of Ruby - Bug #8507: Keyword splat does not convert arg to Hash Rejected

History

#1 - 12/28/2013 02:49 AM - rits (First Last)

this could be used like this: method a: 1, **({b: 1} if condition)

#2 - 08/04/2014 02:48 PM - rits (First Last)

So is there a reason * and ** should work differently for nil?

#3 - 08/11/2014 09:42 AM - marcandre (Marc-Andre Lafortune)

- Assignee set to matz (Yukihiro Matsumoto)

Currently, * uses explicit conversion to array (to_a, not to_ary), while ** uses implicit conversion to hash (to_hash, not to_h).

So your question about nil can be explained this way, since nil.to_a #=> [] but nil.to_hash is not defined.

The real question is then: shouldn't ** be using explicit conversion to hash with to_h?

#4 - 12/18/2019 10:26 AM - mame (Yusuke Endoh)

- Status changed from Open to Rejected

- Backport deleted (1.9.3: UNKNOWN, 2.0.0: UNKNOWN, 2.1: UNKNOWN)

Closing as it is by design.  If you want the change, please open a feature request ticket with a use case.

#5 - 12/19/2019 11:22 PM - mame (Yusuke Endoh)

- Is duplicate of Bug #8507: Keyword splat does not convert arg to Hash added
